#include "W25QXX.h"
uchar W25QXX_RWByte(uchar dat){
    uchar i,res=0;
    for(i=0;i<8;i++){
        SI=dat&0x80;
        CLK=1;
        dat<<=1;
        res<<=1;
        res|=SO;
        CLK=0;   
    }
    SI=1;
    //ģʽ0ʱӼԣ0 ʱλ0
    //˫ǣʱز½ظ
    return res;
}
uchar W25QXX_ReadRegisters(uchar id){
    uchar res;
    CLK=0;
    CS=0;
    if(id==1) W25QXX_RWByte(0x05);//״̬Ĵ1
    if(id==2) W25QXX_RWByte(0x35);//״̬Ĵ2
    res=W25QXX_RWByte(0xff);
    CS=1;
    return res;
}
void W25QXX_WriteRegisters(uchar r1,uchar r2){
    CLK=0;
    CS=0;
    W25QXX_RWByte(0x01);//д״̬Ĵ
    W25QXX_RWByte(r1);//״̬Ĵ1
    W25QXX_RWByte(r2);//״̬Ĵ2
    CS=1;   
}
void W25QXX_WriteEnable(uchar flg){
    CS=0;
    CLK=0;
    if(flg) W25QXX_RWByte(0x06); 
    else W25QXX_RWByte(0x04);    
    CS=1;
    return;
}
uchar W25QXX_TestBusy(){
    uchar res;
    CS=0;
    CLK=0;
    res=W25QXX_ReadRegisters(1);
    CS=1;
    if(res&0x01) return 1;
    else return 0;
}
uchar W25QXX_GetCapacity(){
    uchar res=0;
    CLK=0;
    CS=0;
    W25QXX_RWByte(0x9f);
    W25QXX_RWByte(0xff);
    W25QXX_RWByte(0xff);
    res=W25QXX_RWByte(0xff);
    CS=1;
    if(res==0x14) return 1;//1M Byte
    if(res==0x15) return 2;//2M Byte
    if(res==0x16) return 4;//4M Byte
    if(res==0x17) return 8;//8M Byte
    else return res;
}

void W25QXX_EraseChip(){
    CS=0;
    CLK=0;
    W25QXX_RWByte(0xc7);
    CS=1;
    while(W25QXX_TestBusy());
    return;
}
uchar W25QXX_ReadByte(ulong add){
    uchar res;
    while(W25QXX_TestBusy());
    CS=0;
    CLK=0;
    W25QXX_RWByte(0x03);
    W25QXX_RWByte(add>>16);
    W25QXX_RWByte(add>>8);
    W25QXX_RWByte(add);
    res=W25QXX_RWByte(0xff);
    CS=1;
    return res;   
}
void W25QXX_WriteByte(ulong add,uchar dat){
    while(W25QXX_TestBusy());
    W25QXX_WriteEnable(1);
    CS=0;
    CLK=0;
    W25QXX_RWByte(0x02);
    W25QXX_RWByte(add>>16);
    W25QXX_RWByte(add>>8);
    W25QXX_RWByte(add);
    W25QXX_RWByte(dat);
    CS=1;
    return;
}
void W25QXX_ReadPage(ulong add,uchar dat[]){
    int i;
    CS=0;
    CLK=0;
    W25QXX_RWByte(0x03);
    W25QXX_RWByte(add>>16);
    W25QXX_RWByte(add>>8);
    W25QXX_RWByte(add);
    for(i=0;i<256;i++) {dat[i]=W25QXX_RWByte(0xff);}
    CS=1;
} 
void W25QXX_WritePage(ulong add,uchar dat[]){
    uint i;
    while(W25QXX_TestBusy());
    W25QXX_WriteEnable(1);
    CS=0;
    CLK=0;
    W25QXX_RWByte(0x02);
    W25QXX_RWByte(add>>16);
    W25QXX_RWByte(add>>8);
    W25QXX_RWByte(add);
    for(i=0;i<256;i++) W25QXX_RWByte(dat[i]);
    CS=1;
    return;
}
void W25QXX_EraseSector(ulong add){
    uint i;
    while(W25QXX_TestBusy());
    W25QXX_WriteEnable(1);
    CS=0;
    CLK=0;
    W25QXX_RWByte(0x20);
    W25QXX_RWByte(add>>16);
    W25QXX_RWByte(add>>8);
    W25QXX_RWByte(add);
    CS=1;
    return; 
}    
