#include "STC8H.h"
#include "TYPE.h"
#include "oled.h"
#include "W25QXX.h"
#include "ADC.h"
#include "FAT12.h"
#include "EEPROM.h"
#include <stdio.h> 

#define APP_FLag 0xffff
#define APP_Entry 0x3000
#define BootLoaderSize 0x3000
#define CodeSize 0xCE00//65536-12288-512

sbit key=P3^2;
uchar Key_Scan(){
    uchar i,j;
    uint tmp,samples[11];
    ADC_On();
    for(i=0;i<10;i++){
        samples[i]=ADC_Result(ADC_CH1,ADC_SPEEDLL); 
        for(j=i-1;j>0&&i>0;j--){
            if(samples[j+1]<samples[j]){
                tmp=samples[j+1];
                samples[j+1]=samples[j];
                samples[j]=tmp;
            }
        }          
    }
    if(samples[5]>=0&&samples[5]<=250) return 1;//
    else if(samples[5]>=550&&samples[5]<=750) return 2;//
    else return 0xff;
} 
void delayms(uint t){
    uint i;
    while(t--) for(i=0;i<600;i++);
    return;
}     
FAT12_File p;
uchar CodeBuffer[512];
uchar APP_ID,APP_NUM;
uchar keynum=0;
uint32_t i,j;
ulong Code_ptr=0;
ulong ByteCnt=0,Jindu=0;
void (*App_Jmp)(void);
ulong t0=100,Press=0;
uchar HexBuffer[64];//뵥Ԫ
typedef struct{  
    uchar Hex_Start[1];    
    uchar HexLenth[2];
    uchar HexAddr[4];
    uchar HexAttributes[2];
    uchar HexDat[55];
}Hex_Segment;
Hex_Segment *hs;
uint32_t NxtSeg=0,AddrTmp=0;
uint8_t LenthTmp=0,DataTmp=0;
uint32_t HexOffset=0;
uint32_t Get_int32(uchar a,uchar b,uchar c,uchar d){
    uint32_t res=0;                 
    if(a>='0'&&a<='9') res+=((a-48)*4096);
    else res+=((a-55)*4096);
    if(b>='0'&&b<='9') res+=((b-48)*256);
    else res+=((b-55)*256);
    if(c>='0'&&c<='9') res+=((c-48)*16);
    else res+=((c-55)*16);
    if(d>='0'&&d<='9') res+=((d-48)*1);
    else res+=((d-55)*1);
    return res;
}
uint8_t Get_int8(uchar c,uchar d){
    uint8_t res=0;
    if(c>='0'&&c<='9') res+=((c-48)*16);
    else res+=((c-55)*16);
    if(d>='0'&&d<='9') res+=((d-48)*1);
    else res+=((d-55)*1);
    return res;
}    
void OLED_ShowStr(uchar x,uchar y,uchar str[],uchar num){
    uchar i=0;
    for(i=0;i<num;i++) if(x+i*8<120) OLED_ShowChar(x+i*8,y,str[i],16);
}    
void main(){
    P0M0=0x00;
    P0M1=0x00;
    P1M1=0xf7; 
    P1M0=0x00;   //Ϊ迹
    P2M0=0x00;
    P2M1=0x00;
    P3M0=0x00;
    P3M1=0x00;
    P5M0=0x00;
    P5M1=0x00;    
    EEPROM_Init(40);
    ADC_On();
    OLED_Init();
    OLED_Display_On();
    OLED_Clear();
    OLED_ColorTurn(0);
    while(t0--){
         if(Key_Scan()!=0xff) Press++;
         delayms(10);
    }
    if(Press>50||EEPROM_ReadByte(APP_FLag)==0xff){
        FAT12_Init();
        APP_NUM=FAT12_SearchForApp(1,&p);
        APP_ID=1;
        OLED_ShowString(0,0,"Select APP:",16);
        while(1){
            if(APP_ID>APP_NUM) APP_ID=1;
            if(APP_ID<1) APP_ID=APP_NUM;
            FAT12_SearchForApp(APP_ID,&p);
            if(p.File_Id!=0xffff){
                OLED_ShowNum(0,2,APP_ID,2,16);
                OLED_ShowString(16,2," ",16);
                OLED_ShowStr(24,2,p.File_Name,12);
            }
            keynum=Key_Scan();
            if(keynum==2) APP_ID++;
            if(keynum==1) APP_ID--;
            if(APP_ID>APP_NUM) APP_ID=1;
            if(APP_ID<1) APP_ID=APP_NUM;
            if(!key){
                delayms(10);
                while(!key);
                if(p.File_Size-BootLoaderSize>CodeSize&&p.File_Name[9]=='B'){
                    OLED_ShowString(0,0,"App Too Big!",16);
                    delayms(10000);
                    OLED_Clear();    
                }else{
                    break;
                }
            }
        }       
        if(p.File_Name[9]=='B'){    //.BINļ        
            OLED_Clear();
            FAT12_Fopen(&p,p.File_Name);
            OLED_ShowStr(0,0,p.File_Name,12);          
            OLED_ShowNum(0,2,p.File_Size-BootLoaderSize,6,16);
            OLED_ShowString(48,2," Bytes",16);
            EEPROM_SectorErase(APP_FLag);
            for(i=APP_Entry;i<0xffff-512;i+=512) EEPROM_SectorErase(i);
            OLED_ShowString(0,4,"Load App...",16);  
            FAT12_Fseek(&p,BootLoaderSize,0);
            Code_ptr=APP_Entry;
            Jindu=0;
            while(!FAT12_IsEOF(&p)&&Code_ptr<p.File_Size){
                FAT12_Fread(&p,CodeBuffer,512);
                for(j=0;j<512;j++) EEPROM_WriteByte(Code_ptr++,CodeBuffer[j]);
                Jindu=Code_ptr-BootLoaderSize;
                if(Jindu&&Jindu%512==0)OLED_ShowChar(Jindu/((p.File_Size-BootLoaderSize)/16)*8,6,'#',16);  
            }               
            OLED_ShowChar(120,6,'#',16); 
            EEPROM_WriteByte(APP_FLag,APP_ID);
            Code_ptr=APP_Entry;
        }else{    //HEX¼
            OLED_Clear();
            FAT12_Fopen(&p,p.File_Name);
            OLED_ShowStr(0,0,p.File_Name,12);          
            OLED_ShowNum(0,2,p.File_Size,6,16);
            OLED_ShowString(48,2," Bytes",16);
            EEPROM_SectorErase(APP_FLag);
            for(i=APP_Entry;i<0xffff-512;i+=512) EEPROM_SectorErase(i);
            OLED_ShowString(0,4,"Load App...",16);  
            HexOffset=0;
            FAT12_Fseek(&p,0,0);
            ByteCnt=0;
            while(!FAT12_IsEOF(&p)&&ByteCnt<p.File_Size){
                FAT12_Fread(&p,HexBuffer,64);
                hs=(Hex_Segment*)(HexBuffer);
                AddrTmp=Get_int32(hs->HexAddr[0],hs->HexAddr[1],hs->HexAddr[2],hs->HexAddr[3]);
                LenthTmp=Get_int8(hs->HexLenth[0],hs->HexLenth[1]);
                if(LenthTmp==0) break;
                for(i=0;i<LenthTmp*2;i+=2){
                    DataTmp=Get_int8(hs->HexDat[i],hs->HexDat[i+1]);
                    if(AddrTmp>=APP_Entry){
                        EEPROM_WriteByte(AddrTmp+i/2,DataTmp);
                        ByteCnt++;            
                    } 
                    if(ByteCnt&&ByteCnt%256==0) OLED_ShowChar(Jindu/(p.File_Size/16)*8,6,'#',16);
                }  
                Jindu=HexOffset;               
                HexOffset+=(LenthTmp*2+13);
                FAT12_Fseek(&p,HexOffset,0);
            }   
           EEPROM_WriteByte(APP_FLag,APP_ID);            
        }    
    }  
    App_Jmp=APP_Entry;
    App_Jmp();  
    while(1);  
}